import java.io.ByteArrayOutputStream;
import org.apache.commons.codec.binary.Base64;
import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.entity.StringEntity;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.params.CoreProtocolPNames;

public class HttpPostClient {

	
	/**
	 * @param args
	 */
	/*
	public static void main(String[] args) 
	{
		String url = "http://shockwave:8080/fmerest/notifier/topics/SAMPLE_TOPIC/publish";
		String content = "This is my notification content";
		String userName = "admin";
		String password = "admin";
		
		post(url, userName, password, content);
	}
	*/
	
	public static void post(String url, String userName, String password, String content)
	{						
		String contentEncoding = "UTF-8"; // Use UTF-8 to be i18n friendly
		
		// Create HTTP client and POST request
		DefaultHttpClient client = new DefaultHttpClient();
		HttpPost httpPost = new HttpPost(url);
		
		// HTTP Basic authentication
		if (userName != null && userName.length() > 0 && 
			password != null && password.length() > 0)
		{
			httpPost.setHeader("Authorization",
				    "Basic " + new String (Base64.encodeBase64((userName + ':' + password).getBytes())));
		}
            
		try
		{
			//  Create the request body
			byte[] bytes = content.getBytes(contentEncoding);               
			StringEntity entity = new StringEntity(new String(bytes, contentEncoding), contentEncoding);
			httpPost.setEntity(entity);
			client.getParams().setBooleanParameter(CoreProtocolPNames.USE_EXPECT_CONTINUE, false);   
	         	         
	        // Execute the request
	        HttpResponse response = client.execute(httpPost);
	        // Check status code
	        int status = response.getStatusLine().getStatusCode();         
	        if (status == 200)
	        {
	        	// Success!
	        	System.out.println("POST request succeeded!");
	        }
	        else
	        {	        	
	        	System.out.println("POST request failed with error code: " + status);
	            // We've got an error code, log out the response message
	            ByteArrayOutputStream output = new ByteArrayOutputStream();
	            HttpEntity respEntity = response.getEntity();
			    if (respEntity != null)
			    {
				   respEntity.writeTo(output);                              
				   System.out.println("Error response: " + output.toString());
			    }	                        
	        }
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}		
	}

}
